Index: trunk/tools/bootloader_tsar/boot_config.h
===================================================================
--- trunk/tools/bootloader_tsar/boot_config.h	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_config.h	(revision 6)
@@ -1,6 +1,5 @@
-/****************************************************************************
- * This file defines various hardware and configuration parameters for the  *
- * ALMOS-MKH boot-loader.                                                    *
- ****************************************************************************/
+/*********************************************************************************
+ * This file defines various configuration parameters for ALMOS-MKH boot-loader. 
+ ********************************************************************************/
 
 #ifndef _BOOT_CONFIG_H
@@ -8,40 +7,35 @@
 
 // Debug options
-#define DEBUG_BOOT_INFO     1
-#define DEBUG_BOOT_ELF      1
+#define DEBUG_BOOT_INFO     0
+#define DEBUG_BOOT_ELF      0
 #define DEBUG_BOOT_IOC      0
-#define DEBUG_BOOT_FAT32    1
-#define USE_FIXED_FORMAT    0
+#define DEBUG_BOOT_WAKUP    1
+#define DEBUG_BOOT_FAT32    0
 
-// io_cluster identifier
-#define IO_CXY              0
+// Core identifier format
+#define USE_FIXED_FORMAT    1
 
-// Peripheral base addresses (in io_cluster)
-#define SEG_IOC_BASE        0xb3000000
-#define SEG_TTY_BASE        0xb4000000
-#define SEG_MMC_BASE        0xb2000000
+// cache line
+#define CACHE_LINE_SIZE     64
+
+// Preloader temporary segment
+#define PRELOADER_BASE      0x0             /* Preloader base address.      */
+#define PRELOADER_MAX_SIZE  0x4000          /* Preloader max size.          */
 
 // boot code temporary segment
 #define BOOT_BASE           0x100000        /* 'boot.elf' base address.     */
-#define BOOT_MAX_SIZE       0x100000        /* 'boot.elf' max size.         */
+#define BOOT_MAX_SIZE       0x010000        /* 'boot.elf' max size.         */
 
 // arch_info temporary segment
-#define ARCHINFO_BASE       0x200000        /* 'arch_info.bin' base address */
-#define ARCHINFO_MAX_SIZE   0x200000        /* 'arch_info.bin' max size.    */
+#define ARCHINFO_BASE       0x200000        /* 'arch_info.bin' file base address */
+#define ARCHINFO_MAX_SIZE   0x010000        /* 'arch_info.bin' file max size.    */
 
 // kernel code temporary segment
-#define KERN_BASE           0x400000        /* 'kernel.elf' base address    */
-#define KERN_MAX_SIZE       0x100000        /* 'kernel.elf' max size.       */
-
-// Preloader temporary segment
-#define PRELOADER_BASE      0x0             /* Preloader base address.      */
-#define PRELOADER_MAX_SIZE  0x100000        /* Preloader max size.          */
+#define KERN_BASE           0x400000        /* 'kernel.elf' file base address    */
+#define KERN_MAX_SIZE       0x100000        /* 'kernel.elf' file max size.       */
 
 // Temporary stacks segments
 #define BOOT_STACK_BASE     0x504000        /* Boot stack base address.     */
-#define BOOT_STACK_SIZE     0x1000          /* Boot stack size (4Kb)        */
-
-// Pas clair du tout TODO   [AG]
-#define KERN_IMG_TMP_BASE   0X600000
+#define BOOT_STACK_SIZE     0x4000          /* Boot stack size (16Kb)       */
 
 #endif  // _BOOT_CONFIG_H
Index: trunk/tools/bootloader_tsar/boot_entry.S
===================================================================
--- trunk/tools/bootloader_tsar/boot_entry.S	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_entry.S	(revision 6)
@@ -1,2 +1,25 @@
+/*
+ * boot_entry.S - TSAR bootloader entry point.
+ * 
+ * Authors :   Alain Greiner / Vu Son  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
 /*************************************************************************************************
  * This file contains the entry point of the ALMOS-MK boot-loader for TSAR architecture.         *
@@ -61,26 +84,20 @@
     mfc0    k0,     CP0_PROCID          
     andi    k0,     k0,     0xFFF                       /* k0 <= gid                        */
-    andi    t1,     k0,     ((1 << PADDR_WIDTH) - 1)    /* t1 <= lid                        */
-    srl     t2,     k0,     PADDR_WIDTH                 /* t2 <= cxy                        */
+    andi    t1,     k0,     ((1 << P_WIDTH) - 1)        /* t1 <= lid                        */
+    srl     t2,     k0,     P_WIDTH                     /* t2 <= cxy                        */
     
-    /* 
-     * Initializing stack pointer from previously retrieved lid value.
-     */
+    /* Initialize stack pointer from previously retrieved lid value  */
     
     la      t0,     BOOT_STACK_BASE                     /* t0 <= BOOT_STACK_BASE            */
     li      k1,     BOOT_STACK_SIZE                     /* k1 <= BOOT_STACK_SIZE            */
     multu   k1,     t1
-    mflo    k0,                                         /* k0 <= BOOT_STACK_SIZE * lid      */
+    mflo    k0                                          /* k0 <= BOOT_STACK_SIZE * lid      */
     subu    sp,     t0,     k0                          /* P[cxy,lid] stack top initialized */ 
 
-    /* 
-     * Switching to local DSPACE by changing the value of the address extension registers.
-     */
+    /* Switch to local DSPACE by changing the value of the address extension registers  */
 
     mtc2    t2,     CP2_DATA_PADDR_EXT
 
-    /* 
-     * Jumping to boot_loader() function after passing 2 arguments in the registers.
-     */
+    /* Jump to boot_loader() function after passing 2 arguments in the registers  */
 
     or      a0,     zero,   t1                          /* a0 <= lid                        */     
@@ -96,7 +113,5 @@
  *************/
 
-    /* 
-     * Testing if this is bscpu.
-     */
+    /* Test if this is bscpu  */
 
     mfc0    k0,     CP0_PROCID          
@@ -108,7 +123,5 @@
     li      t4,     BOOT_CORE_CXY                       /* t4 <= bscpu cxy                  */
 
-    /* 
-     * Getting base address of the core descriptor table in 'arch_info.bin' file.
-     */
+    /* Get base address of the core descriptor table in 'arch_info.bin' file */
 
     la      t0,     ARCHINFO_BASE                       /* t0 <= ARCHINFO_BASE              */
@@ -116,7 +129,5 @@
     addu    t2,     t0,     t1                          /* t2 <= ARCHINFO_CORE_BASE         */
 
-    /* 
-     * Scanning the core descriptor table if this is not bscpu. TODO If not found?
-     */
+    /* scan the core descriptor table if this is not bscpu. TODO If not found?  */
 
     li      t3,     0x8                                 /* t3 <= ARCHINFO_CORE_SIZE         */
@@ -127,14 +138,10 @@
     addu    t2,     t2,     t3                          /* t2 <= @ next archinfo_core       */
 
-    /* 
-     * Getting (cxy, lid) values from the found core descriptor.
-     */
+    /* Get (cxy, lid) values from the found core descriptor  */
     
     lw      t3,     -8(t2)                              /* t3 <= lid                        */
     lw      t4,     -4(t2)                              /* t4 <= cxy                        */
 
-    /* 
-     * Initializing stack pointer from previously retrieved lid value.
-     */
+    /* Initialize stack pointer from previously retrieved lid value  */
 
 bscpu_exit:    
@@ -145,13 +152,9 @@
     subu    sp,     t0,     k0                          /* P[cxy,lid] stack top initialized */ 
 
-    /* 
-     * Switching to local DSPACE by changing the value of the address extension registers.
-     */
+    /* Switch to local DSPACE by changing the value of the address extension registers  */
 
     mtc2    t4,     CP2_DATA_PADDR_EXT
 
-    /* 
-     * Jumping to boot_loader() function after passing 2 arguments in the registers.
-     */
+    /* Jumping to boot_loader() function after passing 2 arguments in registers */
 
     or      a0,     zero,   t3                          /* a0 <= lid                        */     
Index: trunk/tools/bootloader_tsar/boot_fat32.c
===================================================================
--- trunk/tools/bootloader_tsar/boot_fat32.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_fat32.c	(revision 6)
@@ -148,5 +148,5 @@
 {
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters at cycle %d\n",
                 __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -163,5 +163,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: FSI Sector loaded at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s : FSI Sector loaded at cycle %d\n",
                 __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -197,5 +197,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: free_clusters_nr = %x / free_cluster_hint = %x\n",
+    boot_printf("\n[BOOT INFO] %s : free_clusters_nr = %x / free_cluster_hint = %x\n",
                 __FUNCTION__ , boot_fat.free_clusters_nr , boot_fat.free_cluster_hint );
 #endif
@@ -430,5 +430,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: returns <%s> from <%s> at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s : returns <%s> from <%s> at cycle %d\n",
                 __FUNCTION__ , path_component , pathname , boot_get_proctime() );
 #endif
@@ -592,5 +592,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters for <%s> file at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters for <%s> file at cycle %d\n",
                 __FUNCTION__ , pathname, boot_get_proctime());
 #endif
@@ -615,7 +615,4 @@
         while ( found == 0 )
         {
-
-boot_printf("\n!!! enter second while for <%s> path_comp\n", path_comp );
-
             cluster_lba = cluster_to_lba( parent_cluster );
             
@@ -646,7 +643,4 @@
                 if (ord == LAST_ENTRY)             // no more entry in this directory
                 {
-
-boot_printf("\n@@@ for <%s> component / offset = %d : last entry\n", path_comp , offset );
-
                     found = 2;
                 }
@@ -654,7 +648,4 @@
                 else if (ord == FREE_ENTRY)        // unused, check the next entry
                 {
-
-boot_printf("\n@@@ for <%s> component / offset = %d : free entry\n", path_comp , offset );
-
                     continue;
                 }
@@ -672,7 +663,4 @@
                     get_name_from_long(entry, buffer_lfn);
 
-boot_printf("\n@@@ for <%s> component / offset = %d : LFN entry = %s\n", 
-            path_comp , offset , buffer_lfn );
-
                     // Append this portion of the name to the full name buffer
                     boot_strcpy(name + 13 * (lfn_seq_order-1) , buffer_lfn);
@@ -685,7 +673,4 @@
                 {
                     if (lfn_seq_elem_nr == 0) get_name_from_short(entry, name);
-
-boot_printf("\n@@@ for <%s> component / offset = %d : SFN entry = %s\n", 
-            path_comp , offset , name );
 
                     // check if the full name is what we are looking for.
@@ -725,6 +710,4 @@
         } // end second while for one component in pathname
         
-boot_printf("\n### exit hwile fpr component <%s>\n", path_comp );
-
         // Check the result of this path component search.
         if (found == 2)
@@ -755,7 +738,7 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] fat_file_search(): "
-                "<%s> file of size %x found at cluster %x at cycle %d\n",
-                pathname, *file_size, *first_cluster, boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : <%s> file found at cycle %d\n"
+                "    fat_cluster = %x / size = %x\n",
+                __FUNCTION__ , pathname , boot_get_proctime() , *first_cluster , *file_size );
 #endif
 
@@ -771,7 +754,4 @@
 int boot_fat32_init()
 {
-
-boot_printf("@@@ BEFORE_VALUE = %x\n", FAT_MAGIC_VALUE);
-
     // FAT32 initialization should be done only once
     if (boot_fat.initialized == FAT_MAGIC_VALUE)
@@ -783,5 +763,5 @@
 
 #if DEBUG_BOOT_FAT32    
-boot_printf("\n[BOOT] %s: Enters at cycle %d\n",
+boot_printf("\n[BOOT INFO] %s: Enters at cycle %d\n",
             __FUNCTION__ , boot_get_proctime() );
 #endif
@@ -799,9 +779,6 @@
 
 #if DEBUG_BOOT_FAT32    
-boot_printf("\n[BOOT] %s: Boot Sector loaded at cycle %d\n",
+boot_printf("\n[BOOT INFO] %s: Boot Sector loaded at cycle %d\n",
             __FUNCTION__ , boot_get_proctime() );
-// unsigned char * data = boot_fat.block_buffer;
-// uint32_t   byte;
-// for( byte = 0 ; byte < 16 ; byte++ ) boot_printf("%d : %x\n", byte , data[byte] );
 #endif
 
@@ -865,8 +842,4 @@
     boot_fat.initialized    = FAT_MAGIC_VALUE;
 
-boot_printf("@@@ AFTER_VALUE = %x\n", FAT_MAGIC_VALUE);
-
-fat32_desc_display();
-    
     // Set information from FS Information Sector
     if (set_fsi()) return -1;
@@ -878,6 +851,6 @@
 #if DEBUG_BOOT_FAT32    
     fat32_desc_display();
-    boot_printf("\n[BOOT] boot_fat32_init(): FAT32 File System initialized at cycle %d\n",
-                boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : FAT32 File System initialized at cycle %d\n",
+                __FUNCTION__ , boot_get_proctime() );
 #endif
 
@@ -907,5 +880,5 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] %s: Enters for file <%s> at cycle %d\n",
+    boot_printf("\n[BOOT INFO] %s enters for file <%s> at cycle %d\n",
                 __FUNCTION__ , pathname, boot_get_proctime() );
 #endif
@@ -973,7 +946,7 @@
 
 #if DEBUG_BOOT_FAT32    
-    boot_printf("\n[BOOT] boot_fat32_load(): "
-                "File <%s> of size %x loaded at address %x at cycle %d\n",
-                pathname, size, buff_addr, boot_get_proctime());
+    boot_printf("\n[BOOT INFO] %s : file <%s> loaded at cycle %d\n"
+                "    address = %x , size = %x\n",
+                __FUNCTION__ , pathname , boot_get_proctime() , buff_addr , size );
 #endif
 
Index: trunk/tools/bootloader_tsar/boot_hba_driver.c
===================================================================
--- trunk/tools/bootloader_tsar/boot_hba_driver.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_hba_driver.c	(revision 6)
@@ -7,4 +7,5 @@
 
 #include <boot_config.h>
+#include <hard_config.h>
 #include <boot_hba_driver.h>
 #include <boot_mmc_driver.h>
@@ -15,6 +16,14 @@
 #endif
 
-#ifndef IO_CXY
-# error "The IO_CXY value should be defined in the 'boot_config.h' file"
+#ifndef Y_IO
+# error "The Y_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef X_IO
+# error "The X_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef Y_WIDTH
+# error "The Y_WIDTH value should be defined in the 'hard_config.h' file"
 #endif
 
@@ -47,5 +56,5 @@
 static uint32_t boot_hba_get_register(uint32_t reg)
 {
-    cxy_t      cxy = IO_CXY;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
     uint32_t * ptr = (uint32_t *)SEG_IOC_BASE + reg;
     
@@ -61,5 +70,5 @@
 void boot_hba_set_register(uint32_t reg, uint32_t val)
 {
-    cxy_t      cxy = IO_CXY;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
     uint32_t * ptr = (uint32_t *)SEG_IOC_BASE + reg;
 
Index: trunk/tools/bootloader_tsar/boot_tty_driver.c
===================================================================
--- trunk/tools/bootloader_tsar/boot_tty_driver.c	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_tty_driver.c	(revision 6)
@@ -1,8 +1,24 @@
-///////////////////////////////////////////////////////////////////////////////////
-// File     : boot_tty_driver.c
-// Date     : 18/01/2017
-// Author   : Alain Greiner / Vu Son
-// Copyright (c) UPMC-LIP6
-///////////////////////////////////////////////////////////////////////////////////
+/*
+ * boot_tty_driver.c - TSAR bootloader TTY driver implementation.
+ * 
+ * Authors :   Alain Greiner / Vu Son  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
 
 #include <boot_config.h>
@@ -11,26 +27,30 @@
 #include <boot_utils.h>
 
-#ifndef SEG_TTY_BASE
-# error "The SEG_TTY_BASE value should be defined in the 'boot_config.h' file"
+#ifndef SEG_TXT_BASE
+# error "The SEG_TXT_BASE value should be defined in the 'hard_config.h' file"
 #endif
 
-#ifndef IO_CXY
-# error "The IO_CXY value should be defined in the 'boot_config.h' file"
+#ifndef X_IO  
+# error "The X_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef Y_IO  
+# error "The Y_IO value should be defined in the 'hard_config.h' file"
+#endif
+
+#ifndef Y_WIDTH
+# error "The Y_WIDTH value should be defined in the 'hard_config.h' file"
 #endif
 
 
-/****************************************************************************
- *                            Internal functions.                           *
- ****************************************************************************/
-
-/****************************************************************************
- * This function returns the value of the a TTY register.                   *
- * @ reg    : TTY register to be read.                                      *
- * @ returns the value stored in 'reg'.                                     *
- ****************************************************************************/
+/////////////////////////////////////////////////////////////////////////////
+// This function returns the value contained in a TTY0 register. 
+// @ reg    : register to be read. 
+// @ returns the value stored in 'reg'.
+/////////////////////////////////////////////////////////////////////////////
 static uint32_t boot_tty_get_register( uint32_t reg )
 {
-    cxy_t      cxy = IO_CXY;
-    uint32_t * ptr = (uint32_t *)SEG_TTY_BASE + reg;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
+    uint32_t * ptr = (uint32_t *)SEG_TXT_BASE + reg;
     
     return boot_remote_lw( XPTR( cxy , ptr ) ); 
@@ -38,14 +58,14 @@
 } // boot_tty_get_register()
 
-/****************************************************************************
- * This function sets a new value to a TTY register.                        *
- * @ reg    : TTY register to be configured.                                *
- * @ val    : new value to be written to 'reg'.                             *
- ****************************************************************************/
+/////////////////////////////////////////////////////////////////////////////
+// This function sets a new value to a TTY0 register.
+// @ reg    : register to be configured.
+// @ val    : new value to be written to 'reg'.
+/////////////////////////////////////////////////////////////////////////////
 static void boot_tty_set_register( uint32_t reg, 
                                    uint32_t val )
 {
-    cxy_t      cxy = IO_CXY;
-    uint32_t * ptr = (uint32_t *)SEG_TTY_BASE + reg;
+    cxy_t      cxy = (X_IO << Y_WIDTH) + Y_IO;
+    uint32_t * ptr = (uint32_t *)SEG_TXT_BASE + reg;
 
     boot_remote_sw( XPTR( cxy , ptr ) , val ); 
@@ -53,41 +73,36 @@
 } // boot_tty_set_register()
 
-/****************************************************************************
- *                           Driver API functions.                          *
- ****************************************************************************/
-
+//////////////////////////////////
 int boot_tty_write( char    * buf,
                     uint32_t  nbytes )
 {
-    uint32_t nb_printed;    /* Iterator for printing loop.              */
-    uint32_t nb_test;       /* Iterator for retry loop.                 */
-    uint32_t error;         /* Used to detect if an error occurs.       */
+    uint32_t nb_printed;
+    uint32_t nb_test;
+    uint32_t error; 
 
-    /* Printing to the boot TTY terminal. */
+    // Print nbytes to TTY0 terminal
     for (nb_printed = 0; nb_printed < nbytes; nb_printed++)
     {
-        // Polling the TTY driver status.
-        if ((boot_tty_get_register(TTY_STATUS) & TTY_WRITE_BUSY))
+        // Poll the TTY0 status.
+        if ((boot_tty_get_register(TTY_STATUS_REG) & TTY_STATUS_TX_FULL))
         {
-            // TTY_WRITE_BUSY bit of TTY_STATUS register is set, keeps polling.
             error = 1;
             for (nb_test = 0; nb_test < 10000; nb_test++)
-                if ((boot_tty_get_register(TTY_STATUS) & TTY_WRITE_BUSY) == 0)
+            {
+                if ((boot_tty_get_register(TTY_STATUS_REG) & TTY_STATUS_TX_FULL) == 0)
                 {
                     error = 0;
                     break;
                 }
+            }
 
-            // Reporting an error if the TTY_WRITE_BUSY bit is still set after
-            // 10000 retries.
-            if (error)
-                return -1;
+            // Report error after 10000 retries.
+            if (error) return -1;
         }
 
-        // Writing a character to the boot TTY terminal. 
+        // Write one character to TTY0 terminal. 
         // Special treatment for a newline: Carriage Return before Line Feed.
-        if (buf[nb_printed] == '\n')
-            boot_tty_set_register(TTY_WRITE, (uint32_t)'\r');
-        boot_tty_set_register(TTY_WRITE, (uint32_t)buf[nb_printed]);
+        if (buf[nb_printed] == '\n') boot_tty_set_register(TTY_WRITE_REG , (uint32_t)'\r');
+        boot_tty_set_register(TTY_WRITE_REG , (uint32_t)buf[nb_printed]);
     }
 
Index: trunk/tools/bootloader_tsar/boot_tty_driver.h
===================================================================
--- trunk/tools/bootloader_tsar/boot_tty_driver.h	(revision 1)
+++ trunk/tools/bootloader_tsar/boot_tty_driver.h	(revision 6)
@@ -1,10 +1,31 @@
+/*
+ * boot_tty_driver.h - TSAR bootloader TTY driver definition.
+ * 
+ * Authors :   Alain Greiner / Vu Son  (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
 /****************************************************************************
- * This file defines a nano-driver for SocLib vci_multi_tty component, used *
- * by the ALMOS-MKH boot-loader.                                             *
- *                                                                          *
- * The SEG_TTY_BASE address must be defined in the 'hard_config.h' file.    *
- *                                                                          *
- * All accesses to the device registers are performed via 2 low-level       *
- * functions 'boot_tty_get_register()' and 'boot_tty_set_register()'.       *
+ * This file defines a nano-driver for SocLib vci_multi_tty component, 
+ * used by the ALMOS-MKH boot-loader.  
+ * The SEG_TTY_BASE address must be defined in the 'hard_config.h' file.
+ * All accesses to the device registers are performed via 2 low-level 
+ * functions 'boot_tty_get_register()' and 'boot_tty_set_register()'.
  ****************************************************************************/
 
@@ -20,8 +41,8 @@
 enum TTY_registers
 {
-    TTY_WRITE   = 0,    /* character to be displayed on screen              */
-    TTY_STATUS  = 1,    /* read and write buffer status                     */
-    TTY_READ    = 2,    /* character in the keyboard                        */
-    TTY_CONFIG  = 3,    /* unused                                           */
+    TTY_WRITE_REG   = 0,    /* character to be displayed on screen          */
+    TTY_STATUS_REG  = 1,    /* read and write buffer status                 */
+    TTY_READ_REG    = 2,    /* character in the keyboard                    */
+    TTY_CONFIG_REG  = 3,    /* unused                                       */
     
     TTY_SPAN    = 4,    /* segment size for one channel ( words )           */
@@ -34,21 +55,18 @@
 enum TTY_status
 {
-    TTY_READ_BUSY   = 1,    /* Set if TTY_READ register contains a data.    */
-    TTY_WRITE_BUSY  = 2,    /* Set if TTY_WRITE register contains a data.   */
+    TTY_STATUS_RX_FULL = 1, /* Set if TTY_READ register contains a data.    */
+    TTY_STATUS_TX_FULL = 2, /* Set if TTY_WRITE register contains a data.   */
 };
 
 /****************************************************************************
- *                           Driver API functions.                          *
- ****************************************************************************/
-
-/****************************************************************************
- * This function writes a character string from the 'buf' buffer to the     *
- * boot TTY terminal. It tests the TTY_STATUS register before writing each  *
- * character of the string to the TTY_WRITE register. If TTY_WRITE_BUSY     *
- * bit is set, it keeps testing the TTY_STATUS register. If after 10000     *
- * retries the bit is still set, the function reports an error and returns. *
- * @ buf    : buffer containing the string to be printed                    *
- * @ nbytes : number of characters to be printed                            *
- * @ returns 0 on success, -1 on error.                                     *
+ * This function writes a character string from the 'buf' buffer to the 
+ * boot TTY terminal. It tests the TTY_STATUS register before writing each
+ * character of the string to the TTY_WRITE register. If TTY_WRITE_BUSY 
+ * bit is set, it keeps testing the TTY_STATUS register. If after 10000 
+ * retries the bit is still set, the function reports an error and returns.
+ ****************************************************************************
+ * @ buf    : buffer containing the string to be printed.                
+ * @ nbytes : number of characters to be printed.                       
+ * @ returns 0 on success, -1 on error.     
  ****************************************************************************/
 int boot_tty_write( char    * buf,
